#include "DistortMeConstants.h"
#include "AUEffectBaseMultichannel.h"
#include "genlib_common.h"
#include <vector>

using std::vector;

class DistortMePlugin;

class DistortMePluginKernel : public AUKernelBaseMultichannel {
public:
	DistortMePluginKernel(DistortMePlugin * inAudioUnit);
	virtual ~DistortMePluginKernel();
	
	
	virtual void Process(
		const vector<const Float32 *> &inSourceP,
		const vector<Float32 *> &inDestP,
		UInt32 inFramesToProcess,
		bool &ioSilence
	);

	DistortMePlugin *plug;
	int bufferSize;
	vector< t_sample * > inputBuffers;
	vector< t_sample * > outputBuffers;
};

class DistortMePlugin : public AUEffectBaseMultichannel {
public:
	DistortMePlugin(AudioUnit component);
	virtual ~DistortMePlugin();
	
	virtual OSStatus Version() { return DistortMe_VERSION; }
	virtual OSStatus Initialize();
	virtual AUKernelBaseMultichannel * NewKernel() { return new DistortMePluginKernel(this); }
	virtual ComponentResult GetParameterInfo(
		AudioUnitScope inScope,
		AudioUnitParameterID inParameterID,
		AudioUnitParameterInfo &outParameterInfo
	);
	virtual ComponentResult SetParameter(
		AudioUnitParameterID inID,
		AudioUnitScope inScope,
		AudioUnitElement inElement,
		AudioUnitParameterValue inValue,
		UInt32 inBufferOffsetInFrames
	);
	
	CommonState *gen;
	int nParams;
};
